import java.util.Vector; 


public abstract class Domain extends NamedElement 
{ boolean isCheckable = false;
  boolean isEnforceable = false;
  QVTRule rule;
  TypedModel typedModel;

  public Domain(String nme, QVTRule r, TypedModel tm)
  { super(nme); 
    rule = r;
    typedModel = tm;
  }

  public void setCheckable(boolean c)
  { isCheckable = c; }

  public void setEnforceable(boolean en)
  { isEnforceable = en; }

  public abstract boolean typeCheck(Vector entities, Vector types, Vector contexts, Vector env);  
   

  public abstract Expression toSourceExpression(Vector bound);

  public abstract Expression toTargetExpression(Vector bound);

  public abstract Expression toSourceExpressionOp(Vector bound);

  public abstract Expression toTargetExpressionOp(Vector bound);
}
