import java.util.Vector; 

/* Copyright K. Lano 2013
   Package: ATL 
*/ 

public class InPattern
{ Vector elements; 

  public InPattern()
  { elements = new Vector(); } 

  public void setElements(Vector elems)
  { elements = elems; } 

  public void addElement(InPatternElement ipe) 
  { elements.add(ipe); } 

  public String toString()
  { String res = "from "; 
    for (int i = 0; i < elements.size(); i++) 
    { InPatternElement ipe = (InPatternElement) elements.get(i); 
      res = res + "    " + ipe; 
      if (i < elements.size() - 1) 
      { res = res + ",\n"; } 
    } 
    return res; 
  } 

  public String firstType()  // Will become the owner of the constraint of the rule
  { if (elements.size() > 0) 
    { InPatternElement ipe = (InPatternElement) elements.get(0); 
      return ipe.getType(); 
    } 
    return null; 
  }

  public Entity firstEntity()
  { if (elements.size() > 0) 
    { InPatternElement ipe = (InPatternElement) elements.get(0); 
      Type typ = ipe.variable.getType();
      if (typ.isEntity())
      { return typ.getEntity(); }  
    } 
    return null; 
  }

  public Expression toExpression()
  { // pre: elements.size() > 0
    InPatternElement ipe0 = (InPatternElement) elements.get(0);
    Expression res = ipe0.condition; 
    for (int i = 1; i < elements.size(); i++)
    { InPatternElement ipe = (InPatternElement) elements.get(i); 
      res = Expression.simplify("&",res,ipe.getFullCondition(),null);  
    } 
    return res; 
  }  

  public Vector allVariables()
  { Vector res = new Vector(); 
    for (int i = 0; i < elements.size(); i++)
    { InPatternElement ipe = (InPatternElement) elements.get(i); 
      if (ipe.variable != null) 
      { res.add(ipe.variable); } 
    } 
    return res; 
  }  
} 