import java.util.Vector; 


public class InPatternElement
{ Attribute variable; 
  Expression condition; 

  public InPatternElement(Attribute att, Expression exp)
  { variable = att;
    condition = exp;
  } 

  public String toString()
  { String res = variable.getName() + " : " + variable.getType(); 
    if (condition == null || "true".equals(condition + ""))
    { return res; } 
    return res + " ( " + condition + " )"; 
  } 

  public void setCondition(Expression cond)
  { condition = cond; } 

  public Expression getFullCondition()
  { BasicExpression be = new BasicExpression(variable.getName()); 
    be.setType(variable.getType()); 
    BasicExpression betype = new BasicExpression(variable.getType() + ""); 
    Expression res = new BinaryExpression(":", be, betype); 
    return Expression.simplify("&", res, condition, null); 
  } 

  public String getType()
  { return variable.getType() + ""; } 
}