import java.util.Vector; 


public class RelationDomain extends Domain
{ Attribute rootVariable;
  DomainPattern pattern;

  public RelationDomain(String nme, QVTRule r, TypedModel tm, Attribute v, DomainPattern p)
  { super(nme, r, tm);
    rootVariable = v;
    pattern = p;
  }

  public Object clone()
  { DomainPattern dp1 = (DomainPattern) ((DomainPattern) pattern).clone(); 
    RelationDomain res = new RelationDomain(name,rule,typedModel,rootVariable,dp1);
    dp1.relationDomain = res;  
    res.isCheckable = isCheckable; 
    res.isEnforceable = isEnforceable; 
    return res; 
  } 

  public String toString()
  { String res = "enforce";
    if (isCheckable)
    { res = "checkonly"; }
    res = res + " domain " + typedModel +
        " " + pattern + ";";
    return res;
  }

  public boolean typeCheck(Vector types, Vector entities, Vector contexts, Vector env)
  { return pattern.typeCheck(types,entities,contexts,env); }  

  public Expression deleteDomainExp()
  { Expression arg = new BasicExpression(rootVariable); 
    return new UnaryExpression("->isDeleted", arg); 
  } 

  public Expression toSourceExpression(Vector bound)
  { Expression contextObj = new BasicExpression(rootVariable);
    Expression res = pattern.toSourceExpression(bound, contextObj); 
    if (pattern != null && pattern.templateExpression != null &&
        (pattern.templateExpression instanceof ObjectTemplateExp))
    { Expression btexp = new BasicExpression(rootVariable);
      Expression scope = 
        new BasicExpression(((ObjectTemplateExp) pattern.templateExpression).referredClass);
      Expression decl = new BinaryExpression(":", btexp, scope); 
      res = Expression.simplify("&",decl,res,null);
    } 
    return res; 
  }

  public Expression toTargetExpression(Vector bound)
  { Expression contextObj = new BasicExpression(rootVariable);
    BasicExpression be = new BasicExpression("true");
    return pattern.toTargetExpression(bound, contextObj, be);
  }

  public Expression toSourceExpressionOp(Vector bound)
  { Expression contextObj = new BasicExpression(rootVariable);
    Expression res = pattern.toSourceExpression(bound, contextObj);  
    return res; 
  }

  public Expression toTargetExpressionOp(Vector bound)
  { Expression contextObj = new BasicExpression(rootVariable);
    BasicExpression be = new BasicExpression("true");
    return pattern.toTargetExpressionOp(bound, contextObj, be);
  }
}

