#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "ocl.h"

#include "app.h"

struct A** a_instances = NULL;
int a_size = 0;

struct B** b_instances = NULL;
int b_size = 0;

struct C** c_instances = NULL;
int c_size = 0;

struct D** d_instances = NULL;
int d_size = 0;

struct A** newAList(void)
{ return (struct A**) calloc(ALLOCATIONSIZE, sizeof(struct A*)); }

struct B** newBList(void)
{ return (struct B**) calloc(ALLOCATIONSIZE, sizeof(struct B*)); }

struct C** newCList(void)
{ return (struct C**) calloc(ALLOCATIONSIZE, sizeof(struct C*)); }

struct D** newDList(void)
{ return (struct D**) calloc(ALLOCATIONSIZE, sizeof(struct D*)); }

int getA_x(struct A* self) { return self->x; }

struct D** getA_dr(struct A* self) { return self->dr; }

int getB_y(struct B* self) { return self->y; }

int getC_z(struct C* self) { return self->z; }

struct A** getD_ar(struct D* self) { return self->ar; }

int getB_x(struct B* self) { return getA_x(self->super); }
struct D** getB_dr(struct B* self) { return getA_dr(self->super); }

int getC_x(struct C* self) { return getA_x(self->super); }
struct D** getC_dr(struct C* self) { return getA_dr(self->super); }

void setA_x(struct A* self, int _value) { self->x = _value; }

void setA_dr(struct A* self, struct D** _value) { self->dr = _value; }

void setB_y(struct B* self, int _value) { self->y = _value; }

void setC_z(struct C* self, int _value) { self->z = _value; }

void setD_ar(struct D* self, struct A** _value) { self->ar = _value; }

void setB_x(struct B* self, int _value) { setA_x(self->super, _value); }
void setB_dr(struct B* self, struct D** _value) { setA_dr(self->super, _value); }

void setC_x(struct C* self, int _value) { setA_x(self->super, _value); }
void setC_dr(struct C* self, struct D** _value) { setA_dr(self->super, _value); }

int* getAllA_x(struct A* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getA_x(_col[i]); }
  return result;
}

int* getAllB_y(struct B* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getB_y(_col[i]); }
  return result;
}

int* getAllB_x(struct B* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getB_x(_col[i]); }
  return result;
}

int* getAllC_z(struct C* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getC_z(_col[i]); }
  return result;
}

int* getAllC_x(struct C* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getC_x(_col[i]); }
  return result;
}

struct A** appendA(struct A* col[], struct A* ex)
   { struct A** result;
     int len = length((void**) col);
     if (len % ALLOCATIONSIZE == 0)
     { result = (struct A**) calloc(len + ALLOCATIONSIZE + 1, sizeof(struct A*));
       int i = 0;
       for ( ; i < len; i++) { result[i] = col[i]; }
     }
     else { result = col; }
     result[len] = ex;
     result[len+1] = NULL;
     return result;
   }

struct B** appendB(struct B* col[], struct B* ex)
   { struct B** result;
     int len = length((void**) col);
     if (len % ALLOCATIONSIZE == 0)
     { result = (struct B**) calloc(len + ALLOCATIONSIZE + 1, sizeof(struct B*));
       int i = 0;
       for ( ; i < len; i++) { result[i] = col[i]; }
     }
     else { result = col; }
     result[len] = ex;
     result[len+1] = NULL;
     return result;
   }

struct C** appendC(struct C* col[], struct C* ex)
   { struct C** result;
     int len = length((void**) col);
     if (len % ALLOCATIONSIZE == 0)
     { result = (struct C**) calloc(len + ALLOCATIONSIZE + 1, sizeof(struct C*));
       int i = 0;
       for ( ; i < len; i++) { result[i] = col[i]; }
     }
     else { result = col; }
     result[len] = ex;
     result[len+1] = NULL;
     return result;
   }

struct D** appendD(struct D* col[], struct D* ex)
   { struct D** result;
     int len = length((void**) col);
     if (len % ALLOCATIONSIZE == 0)
     { result = (struct D**) calloc(len + ALLOCATIONSIZE + 1, sizeof(struct D*));
       int i = 0;
       for ( ; i < len; i++) { result[i] = col[i]; }
     }
     else { result = col; }
     result[len] = ex;
     result[len+1] = NULL;
     return result;
   }

struct A* createA(void)
{ struct A* result = (struct A*) malloc(sizeof(struct A));
  result->x = 0;
  result->dr = NULL;
  a_instances = appendA(a_instances, result);
  a_size++;
  return result;
}

struct B* createB(void)
{ struct B* result = (struct B*) malloc(sizeof(struct B));
  result->y = 0;
  result->super = createA();
  b_instances = appendB(b_instances, result);
  b_size++;
  return result;
}

struct C* createC(void)
{ struct C* result = (struct C*) malloc(sizeof(struct C));
  result->z = 0;
  result->super = createA();
  c_instances = appendC(c_instances, result);
  c_size++;
  return result;
}

struct D* createD(void)
{ struct D* result = (struct D*) malloc(sizeof(struct D));
  result->ar = NULL;
  d_instances = appendD(d_instances, result);
  d_size++;
  return result;
}

struct A** insertA(struct A* col[], struct A* self)
  { if (isIn((void*) self, (void**) col))
    { return col; }
    return appendA(col,self);
  }

struct B** insertB(struct B* col[], struct B* self)
  { if (isIn((void*) self, (void**) col))
    { return col; }
    return appendB(col,self);
  }

struct C** insertC(struct C* col[], struct C* self)
  { if (isIn((void*) self, (void**) col))
    { return col; }
    return appendC(col,self);
  }

struct D** insertD(struct D* col[], struct D* self)
  { if (isIn((void*) self, (void**) col))
    { return col; }
    return appendD(col,self);
  }

 unsigned char existsC(struct C* col[], unsigned char (*test)(struct C*))
 { int n = length((void**) col);
   unsigned char result = FALSE;
   int i = 0;
   for ( ; i < n; i++)
   { struct C* ex = col[i];
     if (ex == NULL) { return result; }
     if ((*test)(ex))
     { return TRUE; }
   }
   return result;
 }

  struct A** subrangeA(struct A** col, int i, int j)
  { int len = length((void**) col);
    if (i < 1) { i = 1; }
    if (j > len) { j = len; }
    if (i > j) { return NULL; }
    struct A** result = (struct A**) calloc(j - i + 2, sizeof(struct A*));
    int k = i-1;
    int l = 0;
    for ( ; k < j; k++, l++)
    { result[l] = col[k]; }
    result[l] = NULL;
    return result;
  }

  struct B** subrangeB(struct B** col, int i, int j)
  { int len = length((void**) col);
    if (i < 1) { i = 1; }
    if (j > len) { j = len; }
    if (i > j) { return NULL; }
    struct B** result = (struct B**) calloc(j - i + 2, sizeof(struct B*));
    int k = i-1;
    int l = 0;
    for ( ; k < j; k++, l++)
    { result[l] = col[k]; }
    result[l] = NULL;
    return result;
  }

  struct C** subrangeC(struct C** col, int i, int j)
  { int len = length((void**) col);
    if (i < 1) { i = 1; }
    if (j > len) { j = len; }
    if (i > j) { return NULL; }
    struct C** result = (struct C**) calloc(j - i + 2, sizeof(struct C*));
    int k = i-1;
    int l = 0;
    for ( ; k < j; k++, l++)
    { result[l] = col[k]; }
    result[l] = NULL;
    return result;
  }

  struct D** subrangeD(struct D** col, int i, int j)
  { int len = length((void**) col);
    if (i < 1) { i = 1; }
    if (j > len) { j = len; }
    if (i > j) { return NULL; }
    struct D** result = (struct D**) calloc(j - i + 2, sizeof(struct D*));
    int k = i-1;
    int l = 0;
    for ( ; k < j; k++, l++)
    { result[l] = col[k]; }
    result[l] = NULL;
    return result;
  }

  struct A** reverseA(struct A** col)
  { int n = length((void**) col);
    struct A** result = (struct A**) calloc(n+1, sizeof(struct A*));
    int i = 0;
    int x = n-1;
    for ( ; i < n; i++, x--)
    { result[i] = col[x]; }
    result[n] = NULL;
    return result;
  }

  struct B** reverseB(struct B** col)
  { int n = length((void**) col);
    struct B** result = (struct B**) calloc(n+1, sizeof(struct B*));
    int i = 0;
    int x = n-1;
    for ( ; i < n; i++, x--)
    { result[i] = col[x]; }
    result[n] = NULL;
    return result;
  }

  struct C** reverseC(struct C** col)
  { int n = length((void**) col);
    struct C** result = (struct C**) calloc(n+1, sizeof(struct C*));
    int i = 0;
    int x = n-1;
    for ( ; i < n; i++, x--)
    { result[i] = col[x]; }
    result[n] = NULL;
    return result;
  }

  struct D** reverseD(struct D** col)
  { int n = length((void**) col);
    struct D** result = (struct D**) calloc(n+1, sizeof(struct D*));
    int i = 0;
    int x = n-1;
    for ( ; i < n; i++, x--)
    { result[i] = col[x]; }
    result[n] = NULL;
    return result;
  }

struct A** removeA(struct A* col[], struct A* ex)
{ int len = length((void**) col);
  struct A** result = (struct A**) calloc(len+1, sizeof(struct A*));
  int j = 0;
  int i = 0;
  for ( ; i < len; i++)
  { struct A* _e = col[i];
    if (_e == NULL)
    { result[j] = NULL;
      return result; 
    }
    if (_e == ex) { }
    else
    { result[j] = _e; j++; }
  }
  result[j] = NULL;
  return result;
}

struct B** removeB(struct B* col[], struct B* ex)
{ int len = length((void**) col);
  struct B** result = (struct B**) calloc(len+1, sizeof(struct B*));
  int j = 0;
  int i = 0;
  for ( ; i < len; i++)
  { struct B* _e = col[i];
    if (_e == NULL)
    { result[j] = NULL;
      return result; 
    }
    if (_e == ex) { }
    else
    { result[j] = _e; j++; }
  }
  result[j] = NULL;
  return result;
}

struct C** removeC(struct C* col[], struct C* ex)
{ int len = length((void**) col);
  struct C** result = (struct C**) calloc(len+1, sizeof(struct C*));
  int j = 0;
  int i = 0;
  for ( ; i < len; i++)
  { struct C* _e = col[i];
    if (_e == NULL)
    { result[j] = NULL;
      return result; 
    }
    if (_e == ex) { }
    else
    { result[j] = _e; j++; }
  }
  result[j] = NULL;
  return result;
}

struct D** removeD(struct D* col[], struct D* ex)
{ int len = length((void**) col);
  struct D** result = (struct D**) calloc(len+1, sizeof(struct D*));
  int j = 0;
  int i = 0;
  for ( ; i < len; i++)
  { struct D* _e = col[i];
    if (_e == NULL)
    { result[j] = NULL;
      return result; 
    }
    if (_e == ex) { }
    else
    { result[j] = _e; j++; }
  }
  result[j] = NULL;
  return result;
}

struct A** removeAllA(struct A* _col1[], struct A* _col2[])
{ int n = length((void**) _col1);
  struct A** result = (struct A**) calloc(n+1, sizeof(struct A*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { struct A* ex = _col1[i];
    if (isIn((void*) ex, (void**) _col2)) {}
    else 
    { result[j] = ex; j++; }
  }
  result[j] = NULL;
  return result;
}

struct B** removeAllB(struct B* _col1[], struct B* _col2[])
{ int n = length((void**) _col1);
  struct B** result = (struct B**) calloc(n+1, sizeof(struct B*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { struct B* ex = _col1[i];
    if (isIn((void*) ex, (void**) _col2)) {}
    else 
    { result[j] = ex; j++; }
  }
  result[j] = NULL;
  return result;
}

struct C** removeAllC(struct C* _col1[], struct C* _col2[])
{ int n = length((void**) _col1);
  struct C** result = (struct C**) calloc(n+1, sizeof(struct C*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { struct C* ex = _col1[i];
    if (isIn((void*) ex, (void**) _col2)) {}
    else 
    { result[j] = ex; j++; }
  }
  result[j] = NULL;
  return result;
}

struct D** removeAllD(struct D* _col1[], struct D* _col2[])
{ int n = length((void**) _col1);
  struct D** result = (struct D**) calloc(n+1, sizeof(struct D*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { struct D* ex = _col1[i];
    if (isIn((void*) ex, (void**) _col2)) {}
    else 
    { result[j] = ex; j++; }
  }
  result[j] = NULL;
  return result;
}

struct A** frontA(struct A* _col[])
{ int n = length((void**) _col);
  return subrangeA(_col, 1, n-1); }

struct B** frontB(struct B* _col[])
{ int n = length((void**) _col);
  return subrangeB(_col, 1, n-1); }

struct C** frontC(struct C* _col[])
{ int n = length((void**) _col);
  return subrangeC(_col, 1, n-1); }

struct D** frontD(struct D* _col[])
{ int n = length((void**) _col);
  return subrangeD(_col, 1, n-1); }

struct A** tailA(struct A* _col[])
{ int n = length((void**) _col);
  return subrangeA(_col, 2, n); }

struct B** tailB(struct B* _col[])
{ int n = length((void**) _col);
  return subrangeB(_col, 2, n); }

struct C** tailC(struct C* _col[])
{ int n = length((void**) _col);
  return subrangeC(_col, 2, n); }

struct D** tailD(struct D* _col[])
{ int n = length((void**) _col);
  return subrangeD(_col, 2, n); }

int op_A(struct A* self)
{ int result = 0; 
  result = 0; 
  result = getA_x(self); 
  return result; 
}

int op_B(struct B* self)
{ int result = 0; 
  result = 0; 
  result = getB_x(self) * getB_y(self); 
  return result; 
}

int op_C(struct C* self)
{ int result = 0; 
  result = 0; 
  result = getC_z(self) * getC_x(self); 
  return result; 
}

void addD_ar(struct D* d_x, struct A* a_x)
{ if (isIn((void*) a_x, (void**) getD_ar(d_x)))
  { return;  } 
  if (length((void**) getD_ar(d_x)) > 0)
  { struct A* a_xx = (struct A*) any((void**) getD_ar(d_x)); 
  setD_ar(d_x, removeA(getD_ar(d_x), a_xx)); 
  setA_dr(a_xx, removeD(getA_dr(a_xx), d_x));  } 
  if (length((void**) getA_dr(a_x)) > 0)
  { struct D* d_xx = (struct D*) any((void**) getA_dr(a_x)); 
  setA_dr(a_x, removeD(getA_dr(a_x), d_xx)); 
  setD_ar(d_xx, removeA(getD_ar(d_xx), a_x));  } 
  setA_dr(a_x, insertD(getA_dr(a_x), d_x)); 
  setD_ar(d_x, insertA(getD_ar(d_x), a_x)); 
}

void removeD_ar(struct D* d_x, struct A* a_x)
{ setA_dr(a_x, removeD(getA_dr(a_x), d_x)); 
  setD_ar(d_x, removeA(getD_ar(d_x), a_x)); 
}

void assignD_ar(struct D* d_x, struct A** a_x)
{ struct A** ar_old_removed = removeAllA(getD_ar(d_x), a_x); 
  struct A** ar_new_added = removeAllA(a_x, getD_ar(d_x)); 
  int ind_boundedloopstatement_222 = 0;
for ( ; ind_boundedloopstatement_222 < length((void**) ar_old_removed); ind_boundedloopstatement_222++)
  { struct A** ar_xx = (ar_old_removed)[ind_boundedloopstatement_222];
    removeD_ar(d_x, ar_xx);   } 
  int ind_boundedloopstatement_234 = 0;
for ( ; ind_boundedloopstatement_234 < length((void**) ar_new_added); ind_boundedloopstatement_234++)
  { void* ar_xx = (ar_new_added)[ind_boundedloopstatement_234];
    addD_ar(d_x, ar_xx);   } 
}

void testuc(void)
{ 
}

int main(int _argc, char* _argv[]) { return 0; }
