import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.print.*; 

import javax.swing.border.Border;
import java.util.EventObject;
import java.util.Vector;
import java.util.List;
import java.util.StringTokenizer; 

public class GraphicsLib extends JPanel 
{ Vector xcoords = new Vector(); 
  Vector ycoords = new Vector(); 
  String plotsymb = "x"; 

  public void paintComponent(Graphics g) 
  { super.paintComponent(g);  //clear the panel
    g.setFont(new Font("Serif", Font.BOLD, 18));
    if (g instanceof Graphics2D)
    { Graphics2D g2 = (Graphics2D) g;
      drawPlot(g2); 
    } 
  } 

  public void plot(String symb, List xs, List ys) 
  { xcoords.clear(); ycoords.clear(); 
    // scale up the x and y, and invert the y
    double xstart = ((Double) xs.get(0)).doubleValue(); 
    double xend = ((Double) xs.get(xs.size() - 1)).doubleValue();
    double xdiff = xend - xstart; 
    double xscale = 500/xdiff; 
    
    for (int i = 0; i < xs.size(); i++) 
    { double x = ((Double) xs.get(i)).doubleValue();
      xcoords.add(new Double((x - xstart)*xscale)); 
    } 
    
    for (int i = 0; i < ys.size(); i++) 
    { double y = ((Double) ys.get(i)).doubleValue();
      ycoords.add(new Double(500 - y)); 
    } 

    plotsymb = symb; 
    repaint(); 
  } 
  
  private void drawPlot(Graphics2D g) 
  { if (xcoords.size() == 0) { return; } 

    double x0 = ((Double) xcoords.get(0)).doubleValue(); 
    double y0 = ((Double) ycoords.get(0)).doubleValue(); 
    g.drawString(plotsymb, (int) x0, (int) y0); 
    for (int i = 1; i < xcoords.size(); i++) 
    { double xi = ((Double) xcoords.get(i)).doubleValue(); 
      double yi = ((Double) ycoords.get(i)).doubleValue(); 
      g.drawString(plotsymb, (int) xi, (int) yi);
      g.drawLine((int) x0, (int) y0, (int) xi, (int) yi); 
      x0 = xi; 
      y0 = yi; 
    } 
  } 
  

  public static void main(String[] args) 
  { JFrame f = new JFrame("Plot function"); 
    f.setSize(500, 500);
    f.setVisible(true);
    GraphicsLib gl = new GraphicsLib(); 
    Container contentPane = f.getContentPane(); 
    JScrollPane scroller = new JScrollPane(gl, 
                      JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                      JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    scroller.setPreferredSize(new Dimension(600,600));
    contentPane.add(scroller, BorderLayout.CENTER);
    Vector xx = new Vector(); 
    xx.add(new Double(0.0)); xx.add(new Double(10.0)); xx.add(new Double(15.0)); xx.add(new Double(20.0)); xx.add(new Double(30.0)); 
    Vector yy = new Vector(); 
    yy.add(new Double(3.0)); yy.add(new Double(6.0)); yy.add(new Double(89.0)); yy.add(new Double(34.0)); yy.add(new Double(55.0)); 
    gl.plot("*",xx,yy); 
  } 
      
}  
    
  